#!/bin/sh

# shell script to ease the use of Puppet from the command line
# Antonino Sabetta - antonino.sabetta@isti.cnr.it

# 
PUPPET_DIR=PuppetD4.3

# relative to PUPPET_DIR
PUPPET_LIBS=puppetLibs
PUPPET_EXT_LIBS=externalLibs

CLASSPATH=${PUPPET_LIBS}/MappedQC.jar:\
${PUPPET_LIBS}/MappedSLO.jar:\
${PUPPET_LIBS}/puppetQC.jar:\
${PUPPET_LIBS}/puppetScope.jar:\
${PUPPET_LIBS}/puppetSLO.jar:\
${PUPPET_LIBS}/puppetTerm.jar:\
${PUPPET_LIBS}/trueGTList.jar:\
${PUPPET_LIBS}/wsagreement.jar:\
${PUPPET_EXT_LIBS}/activation.jar:\
${PUPPET_EXT_LIBS}/antlr-2.7.7.jar:\
${PUPPET_EXT_LIBS}/axis-ant.jar:\
${PUPPET_EXT_LIBS}/axis.jar:\
${PUPPET_EXT_LIBS}/commons-discovery.jar:\
${PUPPET_EXT_LIBS}/commons-logging.jar:\
${PUPPET_EXT_LIBS}/ini4j-compat.jar:\
${PUPPET_EXT_LIBS}/ini4j.jar:\
${PUPPET_EXT_LIBS}/java-getopt-1.0.13.jar:\
${PUPPET_EXT_LIBS}/jaxrpc.jar:\
${PUPPET_EXT_LIBS}/jdom.jar:\
${PUPPET_EXT_LIBS}/jsr173_1.0_api.jar:\
${PUPPET_EXT_LIBS}/log4j-1.2.8.jar:\
${PUPPET_EXT_LIBS}/mail.jar:\
${PUPPET_EXT_LIBS}/minerva2.jar:\
${PUPPET_EXT_LIBS}/retroweaver-rt-1.2.1.jar:\
${PUPPET_EXT_LIBS}/saaj.jar:\
${PUPPET_EXT_LIBS}/SSMSimulator3.jar:\
${PUPPET_EXT_LIBS}/stringtemplate.jar:\
${PUPPET_EXT_LIBS}/uk.ac.ucl.cs.slangta_0.0.1.jar:\
${PUPPET_EXT_LIBS}/wsdl4j.jar:\
${PUPPET_EXT_LIBS}/xbean.jar:\
${PUPPET_EXT_LIBS}/xercesImpl.jar:\
${PUPPET_EXT_LIBS}/xmlsec.jar

if [ -z $1 ];
then
    echo "No argument supplied."
    echo "Please specify a valid puppet initialization file."
    echo "  example:"
    echo "    puppet.sh example/eHealthScenario3/configuration.ini "
    echo "Exiting."
    exit
fi

java -cp $CLASSPATH:puppet.jar puppet.Puppet $1















