package puppet;


import it.cnr.isti.setest0.puppetScope.MethodDocument;
import it.cnr.isti.setest0.puppetScope.PuppetScopeDocument;
import it.cnr.isti.setest0.puppetScope.PuppetScopeDocument.PuppetScope;

import java.util.Iterator;
import java.util.List;

import org.ggf.schemas.graap.x2005.x09.wsAgreement.GuaranteeTermType;
import org.ggf.schemas.graap.x2005.x09.wsAgreement.ServiceSelectorType;

public class ServiceScopeManipulator
{    
//    private static String methodRegExpr1 = "public\\s+\\p{Alpha}(\\p{Alnum})+\\s+";
    private static String methodRegExpr1 = "public\\s+\\p{Alpha}[\\p{Alnum}_.]*\\s+";
    private static String methodRegExpr2 = "\\s*[(]\\s*";
    private static String methodRegExpr3 = "\\s*[)]\\s*throws\\s+java.rmi.RemoteException\\s+[{]";
    
    public ServiceScopeManipulator()
	{}
	
	private String GetElencoParametri(MethodDocument.Method Metodo)
	{
		String CharExpr="\\p{Alpha}[\\p{Punct}*\\p{Alnum}*]*";
		String Ritorno = "";
		try
		{
			Iterator ElencoParametri = Metodo.getParametersList().iterator();
			//System.out.println(Metodo.getParametersList().size());
			if(Metodo.getParametersList().size()>=1)
			{
				
				while(ElencoParametri.hasNext())
				{	
					String parametroTemporaneo = (String) ElencoParametri.next();
					Ritorno = Ritorno + "(\\s*"+parametroTemporaneo+"\\s+"+CharExpr+"\\s*[,]*\\s*)+";
				}
				//Ritorno = Ritorno.substring(0, Ritorno.length()-1); //tolgo il "," finale
			}
			else
			{
				Ritorno="("+CharExpr+"\\s+"+CharExpr+"[,]*\\s*)+";
			}
		}
		catch(Exception e){}
		return Ritorno;
	}
//----*****************************************************************************************
	public String[] getListServiceScope(GuaranteeTermType GTT)
	{
		String[] ListaServizi = null;
		System.out.println("getListServiceScope....");
		//int i=0;
		try
		{
			//per come � stato strutturato puppetScope, tutti i servizi a cui va applicato il
			//Guarantee Term vengono inseriti in un unico ServiceScope
			List listaServiceScope = GTT.getServiceScopeList();		
			Iterator p = listaServiceScope.iterator();
			//mi Salvo il nome del servizio
			ListaServizi = new String[listaServiceScope.size()];
			for(int conta=0;conta<listaServiceScope.size();conta++)
			{
				ServiceSelectorType Selector = (ServiceSelectorType)p.next();
				ListaServizi[conta] = Selector.getServiceName();
				//
				//System.out.println("ServiceScopeManipulator"+ListaServizi[i]);
			
			}
		}
		catch(Exception e)
		{System.out.println("ServiceScopeManipulator: getListServiceScope "+e);}
		return ListaServizi;
	}
	
//---**********************************************************************************
	public PuppetScope GetPuppetScope(String NameService,GuaranteeTermType GTT)
	{
		PuppetScopeDocument ScopeDoc = null;
		List listaServiceScope = GTT.getServiceScopeList();
		Iterator p = listaServiceScope.iterator();
		while(p.hasNext())
		{
			ServiceSelectorType Selector = (ServiceSelectorType)p.next();
			//Se il sevizio � quello che ci interessa
			if(NameService.equals(Selector.getServiceName()))
			{
				try
				{
					//Devo ricavare il nome di tutti i metodi
					ScopeDoc = PuppetScopeDocument.Factory.parse(Selector.toString());
				}
				catch(Exception e){}
			}
		}
		return ScopeDoc.getPuppetScope();
	}
//---**********************************************************************************
	public String[] getMethods(String nameservice,GuaranteeTermType GTT)
	{
		//System.out.println("getMethods:"+nameservice);
		String[] StringaDaRestituire=null;
		PuppetScope ScopeDoc = null;
		try
		{
			ScopeDoc = this.GetPuppetScope(nameservice, GTT);
		}catch(Exception e){System.out.println("ServiceScopeManipulator getMethods "+e);}
		Iterator ListaMetodi = ScopeDoc.getMethodList().iterator();
		StringaDaRestituire = new String[ScopeDoc.getMethodList().size()];
		for(int contaServizi=0;contaServizi<ScopeDoc.getMethodList().size();contaServizi++)
		{
			MethodDocument.Method Metodo =(MethodDocument.Method)ListaMetodi.next();
			try
			{
				//Nel Caso il metodo abbia dei parametri che lo differenziano da altri metodi 
				//della stessa classe...
				//La stringa deve rispettare il seguente pattern:
				//"public [a-zA-Z]+ listenFattoriale_rpc[(]([a-zA-Z]+ [0-9a-zA-Z]+[,]*)+[)] throws java.rmi.RemoteException [{]"
				StringaDaRestituire[contaServizi]= methodRegExpr1+Metodo.getNameMethod()+methodRegExpr2+GetElencoParametri(Metodo)+methodRegExpr3;
				//System.out.println("ServiceScopeManipulator:getMethod "+StringaDaRestituire[contaServizi]);
			}	
			catch(Exception e){System.out.println("ServiceScopeManipulator:GetMethods "+e);}
		}	
		
		return StringaDaRestituire;
	}
	
/*
 *  This method is required since the method list obtaned from getMethods actually is list 
 *  of regular expressions for methods name instead of a real method list.
 *  With this you ectract the method name from th regExpr. 
 */
    public static String purgeMethodName (String confusedMethodName){
        int fixedStringLength = methodRegExpr1.length() + methodRegExpr2.length() + methodRegExpr3.length(); 

        boolean foundMethodRegExpr2Offset=false;
        int offsetIndex = 0;
        for ( offsetIndex=methodRegExpr1.length() ; (offsetIndex < confusedMethodName.length()-methodRegExpr2.length()) && (!foundMethodRegExpr2Offset); offsetIndex++)
            foundMethodRegExpr2Offset = confusedMethodName.startsWith(methodRegExpr2, offsetIndex);
        int methodStringLength =  offsetIndex -methodRegExpr1.length();
        
        int methodStringStartIndex = methodRegExpr1.length();
        int methodStringEndIndex = methodRegExpr1.length() + methodStringLength-1; 
        String purgedMethod =  confusedMethodName.substring(methodStringStartIndex, methodStringEndIndex); 
        return purgedMethod; 
    }
}
