/* Generated By:JJTree: Do not edit this line. ASTVarAssignment.java */

/* Copyright (C) 2007 Lars Frantzen
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * See the LICENSE file for the full license
 */

package info.frantzen.testing.ssmsimulator.interpreter.javacc;

import info.frantzen.testing.ssmsimulator.ssm.InteractionVariable;
import info.frantzen.testing.ssmsimulator.ssm.LocationVariable;
import java.util.ArrayList;
import info.frantzen.testing.ssmsimulator.ssm.Variable;
import info.frantzen.testing.ssmsimulator.types.ComplexType;
import info.frantzen.testing.ssmsimulator.types.ComplexTypeInstance;
import info.frantzen.testing.ssmsimulator.types.SimpleType;
import info.frantzen.testing.ssmsimulator.types.Type;
import info.frantzen.testing.ssmsimulator.types.TypeInstance;
import java.util.Iterator;

public class ASTVarAssignment extends SimpleNode {
    public ASTVarAssignment(int id) {
        super(id);
    }
    
    public ASTVarAssignment(DumontParser p, int id) {
        super(p, id);
    }
    
    
    public void interpret() throws DumontParser.RuntimeViolation {
        ArrayList<String> names = ((ASTId)jjtGetChild(0)).names;
        
        // System.out.println("VarAssignment assigns new value to: " + names);
        int nameIndex = 0;
        
        
        String varName = names.get(nameIndex++);
        Variable var = null;
        var = findVariable(varName);
        
        
        
        // Object o = getParser().getSymTab().get(names.get(nameIndex++));
        if (var == null) {
            // TODO throw an exception
            System.err.println("Undefined variable found in ASTVarAssignment.java: " + names.get(0));
            System.exit(1);
        }
        
        // This variable must be an LocationVariable, hence it is initialised
        //Variable var = (Variable) o;
        
        Type type = var.getType();
        TypeInstance instance = var.getInstance();
        
        int fieldIndex = -1;
        
        // we have a complex type, a complex type instance, and a name: names.get(nameIndex)
        while ((type instanceof ComplexType) && (nameIndex < names.size())) {
            // System.out.println("Checking: " + type.getName() + " " + instance.toString());
            // The fields are name / Type pairs
            Object[][] fields = ((ComplexType) type).getFields();
            for (int i=0; i<fields.length; i++) {
                if ( ((String) fields[i][0]).equals(names.get(nameIndex)) ) {
                    fieldIndex = i;
                    type = (Type) fields[i][1];
                    break; }
            }
            nameIndex++;
            // The fields are TypeInstances of the corresponding Types
            Object[] fieldvalues = (Object[]) ((ComplexTypeInstance) instance).getValue();
            instance = (TypeInstance) fieldvalues[fieldIndex];
        }
        
        jjtGetChild(1).interpret();
        
        // System.out.println("Old value was:\n" + instance);
        
        Object p = stack[top];
        if (p instanceof TypeInstance)
            instance.setValue(((TypeInstance) p).getValue());
        else {
            SimpleType stype = (SimpleType) type;
            String restriction = stype.getRestriction();
            if (restriction == "Boolean") {
                Boolean b = (Boolean) p;
                if (stype.checkRestriction(b))
                    instance.setValue(b);
                else
                    throw new DumontParser.RuntimeViolation("Restriction violaton for Boolean, found: " + b);
            }
            if (restriction == "Integer") {
                Integer b = (Integer) p;
                if (stype.checkRestriction(b))
                    instance.setValue(b);
                else
                    throw new DumontParser.RuntimeViolation("Restriction violaton for Integer, found: " + b);
            }
            if (restriction == "Double") {
                Double b = (Double) p;
                if (stype.checkRestriction(b))
                    instance.setValue(b);
                else
                    throw new DumontParser.RuntimeViolation("Restriction violaton for Double, found: " + b);
            }
            if (restriction == "String") {
                String b = (String) p;
                if (stype.checkRestriction(b))
                    instance.setValue(b);
                else
                    throw new DumontParser.RuntimeViolation("Restriction violaton for String, found: " + b);
            }
        }
        
        // System.out.println("New value is:\n" + instance);
        
//        getParser().getSymTab().put(name, stack[top]);
    }
    
    
    
    public int typeCheck() throws DumontParser.IllegalTypeException {
        
        // SimpleType restrictions cannot be checked statically.
        
        int type0 = jjtGetChild(0).typeCheck();
        int type1 = jjtGetChild(1).typeCheck();
        
        if (type0 == type1)
            return type0;
        
        if ((type0 == DumontParserConstants.FLOAT) && (type1 == DumontParserConstants.INT))
            return type0;
        
        throw new DumontParser.IllegalTypeException("Types of variable and value do not match in assignment.");
    }
    
    public String getPrologQuery() throws DumontParser.RuntimeViolation {
        throw new DumontParser.RuntimeViolation("A prolog query was tried to be generated for a var assignment!");
    }
    
    private Variable findVariable(final String varName) {
        
        ArrayList<Variable> vars = new ArrayList(getParser().getVariables());
        for (Iterator it = vars.iterator(); it.hasNext(); ) {
            Variable v = (Variable) it.next();
            if (v.getName().equals(varName)) {
                if (v instanceof LocationVariable)
                    return v;
                if (v instanceof InteractionVariable)
                    // v.getType()
                    if (getParser().getSwitch().getMessage().getType().contains(v))
                        return v;
            }
        }
//
//        ArrayList<InteractionVariable> mtype = getParser().getSwitch().getMessage().getType();
//
//        System.out.println(getParser().getSwitch());
//        if (mtype == null)
//            System.out.println("XXXXXXXXXXXXXXXXXXXXXXXX");
//
//        for (Iterator it = mtype.iterator(); it.hasNext(); ) {
//            InteractionVariable v = (InteractionVariable) it.next();
//            if (v.getName().equals(varName))
//                var = v;
//        }
        return null;
    }
    
}
