/*
 * InteractionVariable.java
 * Copyright (C) 2007 Lars Frantzen
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * See the LICENSE file for the full license
 *
 * Created on 2. Januar 2007, 16:06
 *
 */

package info.frantzen.testing.ssmsimulator.ssm;

import info.frantzen.testing.ssmsimulator.types.Type;

/**
 * An interaction variable is a Variable which is used as a parameter for messages.
 * In WSDL such a variable is called a <I>part</I> of a message.<br>
 * <br>
 * Every interaction variable has an additional WSDLName, which can be different from
 * the name. This is necessary when <I>part</I>s of WSDL messages have the same name but
 * different types. It is needed to map such overloaded parts to seperate interaction
 * variables. For a testing engine it is necessary again to know the original (possibly)
 * overloaded WSDL name to construct the proper SOAP message. If no overloading is
 * present, the WSDLName corresponds to the name of the variable.
 * @author Lars Frantzen
 * @version 0.2
 */
public class InteractionVariable extends Variable {
    
//     private String WSDLName;
    // private Message myMessage;
    
    /**
     * Creates a new instance of InteractionVariable.
     * Note that interaction variables are not constructed with an initialisation since they
     * get values assigend during an interaction.
     * @param WSDLName the WSDL name of the interaction variable
     * @param name the name of the variable
     * @param type the type of the variable
     */
    public InteractionVariable(String name, Type type) {
        super(name,type);
    }

//    public void setMessage(Message m) {
//        myMessage = m;
//    }
//    
//    public Message getMessage() {
//        return myMessage;
//    }
    
}
