/*
 * ST_DoubleInstance.java
 * Copyright (C) 2007 Lars Frantzen
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * See the LICENSE file for the full license
 *
 * Created on 30. Dezember 2006, 14:41
 *
 */

package info.frantzen.testing.ssmsimulator.types;

/**
 * An ST_DoubleInstance is an instance of an {@link ST_Double}.
 * @author Lars Frantzen
 * @version 0.1
 */
public class ST_DoubleInstance extends SimpleTypeInstance {
    
    /**
     * Creates a new instance of ST_DoubleInstance.
     * @param value a Double represented by the ST_DoubleInstance
     */
    public ST_DoubleInstance(Double value) {
        super(value);
    }

    /**
     * A string representation of the ST_DoubleInstance.
     * @return a string representation of the ST_DoubleInstance
     */
    public String toString() {
        return ((Double) getValue()).toString();
    }

    /**
     * Clones this ST_DoubleInstance.
     * @return the cloned ST_DoubleInstance
     */
    public ST_DoubleInstance clone() {
        return new ST_DoubleInstance(new Double((Double) getValue()));
    }

    
}
