/*
 * TypedList.java
 *
 * Created on July 11, 2007, 3:44 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package info.frantzen.testing.ssmsimulator.types;

import java.util.ArrayList;
import javax.xml.namespace.QName;

/**
 *
 * @author Lars Frantzen
 */
public class TypedList extends Type {
    
    private Type myType;
    
    /**
     * Creates a new instance of TypedList
     */
    public TypedList(QName name, Type myType) {
        super(name);
        this.myType = myType;
    }
    
    public Type getType() {
        return myType;
    }
    
    public TypedListInstance generateInitialInstance() {
        return new TypedListInstance(new ArrayList());
    }
    
    public TypedListInstance generateRandomInstance() {
        ArrayList al = new ArrayList();
        al.add(myType.generateRandomInstance());
        al.add(myType.generateRandomInstance());
        al.add(myType.generateRandomInstance());
        return new TypedListInstance(al);
    }
    
    // This is not implemented. This is only meaningful for a concrete instance..
    public TypedListInstance generateNextBoundaryInstance() {
        return null;
    }
    
    // This is not implemened, to give a meaningful value here, the instance must be known,
    // what is not the case...
    public int numberOfBoundaryInstances() {
        return 42;
    }
    
    public boolean checkConsistency() {
        return ((super.getName() != null) && (myType != null));
    }
    
    public String toString() {
        return "TypedList";
    }

    public String getTypeIdentifier() {
        return this.toString();
    }
}
